struct factory {
	double x;
	double y;
	double capacity;
};

struct customer {
	double x;
	double y;
	double lb_demand;
	double ub_demand;
	double nominal_demand;
};

struct demand_factor {
	double x;
	double y;
	double lb_demand;
	double ub_demand;
};

struct t_dr_node {
	int node_number;
	int time;
	int i_dr;
	double total_demand;
	int nb_of_children;
	int nb_of_parents;
	int* children;
	int* parents;
	int which_vertex_worst;
};

struct t_dr_dec_node {
	int dec_number;
	int time;
	int i_dr;
	double total_demand;
	int nb_of_children;
	int nb_of_parents;
	int* children;
	bool* children_worst;
	bool* children_worst_no_IU;
	bool* children_possible;
	int* parents;
	bool* parents_possible;
	int worst_TBD_child;
	int worst_TBD_child_no_IU;
	double han_cost;
	double han_plus_cost_to_go;
	double han_cost_no_IU;
	double han_plus_cost_to_go_no_IU;
	bool han_cost_computed;
	bool han_cost_computed_no_IU;
	bool total_cost_computed;
	bool total_cost_computed_no_IU;
};

struct arc {
	int start_node;
	int end_node;
};

struct param_combination {
	int i_nb;
	double b_cost;
	double m_cost;
	double r_cost;
};

struct solution {
	int* x;
	double** y_0;
	double*** y;
	double** w_0;
	double*** w;
	double ub_cost;
};

struct problem_state {
	int* how_many_dec_there;
	int* how_many_unique_dec_there;
	int* how_many_i_dr;
	int T;
	int nb_locations;
	int nb_customers;
	double** c;
	int nb_of_arcs;
	int nb_nodes;
	int nb_TBD_nodes;
	arc* arcs;
	t_dr_node* nodes;
	t_dr_dec_node* TBD_nodes;
	customer* customers;
	factory* factories;
	double TimeLimit;
	double m_cost;
	double b;
	double revenue;
	int** map_TB_to_node;
	int*** map_TBD_to_node;
	double*** policies_x;
	bool* which_TD;
	int* which_TD_which_vertex;
	int nb_active_nodes;
	std::string output_file;
	std::string log_file;
	std::string policies_file;
	double uncertainty_level;
	int nb_factors;
	demand_factor* demand_factors;
	double** Phi; // Factor sensitivities
	int i_instance;
	GRBEnv* env;
	int solution_method;
};

struct solver_result {
    double obj_value;
	double lower_bound;
    bool optimal;
};